#pragma once
#include "gui/guecstra.hpp"
#include "levelmanager.hpp"
#include <SFML/Graphics/RenderWindow.hpp>
#include <SFML/Graphics/Font.hpp>
#include <guecs/ui.hpp>
#include "events.hpp"

namespace gui {
  class LootUI {
    public:
      bool active = false;
      guecs::UI $gui;
      GameLevel $level;
      std::unordered_map<DinkyECS::Entity, DinkyECS::Entity> contents;

      LootUI(GameLevel level);

      void init();
      void update();
      void render(sf::RenderWindow& window);
      void update_level(GameLevel &level);
      bool mouse(float x, float y, bool hover);
      std::optional<DinkyECS::Entity> start_grab(DinkyECS::Entity slot);
      guecs::GrabSource& get_grab_source(DinkyECS::Entity entity);
      bool has_grab_source(DinkyECS::Entity gui_id);
      void commit_drop(DinkyECS::Entity slot_id);
  };
}
